' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/01/24 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmMain

    '͈
    Private m_ExeRegion As New FvRectangle

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'IꂽrfIݒt@C̃tpX
    Private m_strVideoConfFilePath As String

    'ƃfBNg
    Private m_strDirectory As String

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intErr As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile
        Dim frmLicence As New frmLicence

        m_blnVideoOpened = False
        btnGrab.Enabled = False

        '͈͂̏lݒ(摜̑Sʂɐݒj
        m_ExeRegion.xs = -1
        m_ExeRegion.xe = -1
        m_ExeRegion.ys = -1
        m_ExeRegion.ye = -1

        'ƃfBNgޔ
        m_strDirectory = Directory.GetCurrentDirectory()

        'gp̊mF
        If frmLicence.ShowDialog() = Yes Then
            'rfIݒt@C̑I
            m_strVideoConfFilePath = ""
            If frmVideoConf.ShowDialog() = OK Then
                m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
            End If

            If m_strVideoConfFilePath.Length <> 0 Then
                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                'Lv`{[h̃I[v
                Try
                    AxFvxVideo1.OpenDevice()
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("Lv`{[h̃I[vɎs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'VideoConfFile̕ύXOpenDevicesƃgK[h̕ύX܂B
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂Ɉꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'ۂ̃vOł͂g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂĂB
                'i荞݃TCYImagẽTCYႤꍇ̓G[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

                Try
                    '捞
                    AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("rfI̎捞Ɏs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'Lv`{[h̏Ԃۑ
                m_blnVideoOpened = True
                btnGrab.Enabled = True
            End If
        Else
            'uӂ܂vIꂽꍇ̓TvvOI
            End
        End If

        'ʂ̐
        AxFvxDisplayEx1.CreateDisplay()
        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

        '͈͂Kp
        AxFvxGrayFilter1.SetInspectArea(m_ExeRegion)
        AxFvxDisplayEx1.ClearOverlay()
        AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
        AxFvxDisplayEx1.DrawData(0, m_ExeRegion)

    End Sub

    'EBhETCYύXꂽƂ̏
    Private Sub frmMain_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize

        If Me.WindowState = 0 Or Me.WindowState = 2 Then
            Dim newSize As New Size
            newSize.Width = Me.Width - AxFvxDisplayEx1.Left - 20
            newSize.Height = Me.Height - AxFvxDisplayEx1.Top - 55
            AxFvxDisplayEx1.Size = newSize
        End If

    End Sub

    Private Sub frmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If m_blnVideoOpened = True Then
            'Lv`{[hI[vĂꍇ̓N[Y
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    '͈͂̐ݒ
    Private Sub btnExeRegion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExeRegion.Click

        Dim intOK As Integer
        Dim dblTemp As Double

        AxFvxROI1.SetRectangle(m_ExeRegion)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.UsePoint = False
        AxFvxROI1.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(m_ExeRegion)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If m_ExeRegion.xe < m_ExeRegion.xs Then
                dblTemp = m_ExeRegion.xs
                m_ExeRegion.xs = m_ExeRegion.xe
                m_ExeRegion.xe = dblTemp
            End If
            If m_ExeRegion.ye < m_ExeRegion.ys Then
                dblTemp = m_ExeRegion.ys
                m_ExeRegion.ys = m_ExeRegion.ye
                m_ExeRegion.ye = dblTemp
            End If

            '͈͂Kp
            AxFvxGrayFilter1.SetInspectArea(m_ExeRegion)
            AxFvxDisplayEx1.ClearOverlay()
            AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
            AxFvxDisplayEx1.DrawData(0, m_ExeRegion)
        End If

    End Sub

    'J摜荞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        '摜t@Cǂݍ݂ɂĉ摜TCY
        'ύXĂ\邽߁AChangeImageSizesĂ܂B
        '摜TCYύX\ꍇ́AɈxsΖ肠܂B
        AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

        Try
            '捞
            AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
        Catch ex As System.Exception
            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("rfI̎捞Ɏs܂ErrCode=" + intErr.ToString(), vbExclamation, "G[")
        End Try

        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    '摜t@CǍ
    Private Sub btnLoadImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImage.Click

        '_CAOɂĉ摜t@CI
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        OpenFileDialog1.DefaultExt = "*.bmp"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length > 0 Then

            'FvxFileAccesspăt@CFvxImageɉ摜Ǎ
            AxFvxFileAccess1.FilePath = OpenFileDialog1.FileName

            Try
                AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("Ǎ݂Ɏs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ǂݍݎs")
                Exit Sub
            End Try

            '摜^Cv`FbN
            If AxFvxImage1.BitPerPixel <> 8 Or AxFvxImage1.ImageType <> FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray Then

                MsgBox("8bitOC̉摜ł͂܂", , "error")
                AxFvxImage1.BitPerPixel = 8
                AxFvxImage1.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray
                AxFvxImage1.ImageWidth = 512
                AxFvxImage1.ImageHeight = 480
            End If

            '摜\
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        End If

    End Sub

    '摜t@Cۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ۑs")
                Exit Sub
            End Try
        End If

    End Sub

    'ωtB^
    Private Sub btnAveraging_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAveraging.Click

        '摜̈ꕔ̏ꍇɁAȊǑ摜ۑ悤ɂ邽߂ɃRs[܂
        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())

        'tB^s
        AxFvxGrayFilter1.Averaging(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx())

        'ωɑĕʂ̏ł悤ɁÃC[WɃRs[Ă܂
        'ÃRs[sƉ摜̗L͈͂ZbgĂ܂܂
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    'vVAtB^
    Private Sub btnLaplacian_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLaplacian.Click

        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())
        AxFvxGrayFilter1.Laplacian(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx())
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    'ߖTŏltB^
    Private Sub btnMinFilter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMinFilter.Click

        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())
        AxFvxGrayFilter1.MinFilter(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx())
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    'ߖTőltB^
    Private Sub btnMaxFilter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMaxFilter.Click

        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())
        AxFvxGrayFilter1.MaxFilter(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx())
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    '4ߖTŏltB^
    Private Sub btnMin4Filter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMin4Filter.Click

        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())
        AxFvxGrayFilter1.Min4Filter(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), FVXCOMGRAYFILTERLib.MINMAX4_MODE_TYPE.ALL_MODE)
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    '4ߖTőltB^
    Private Sub btnMax4Filter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMax4Filter.Click

        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())
        AxFvxGrayFilter1.Max4Filter(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), FVXCOMGRAYFILTERLib.MINMAX4_MODE_TYPE.ALL_MODE)
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    'fBAtB^
    Private Sub btnMedian_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMedian.Click

        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())
        AxFvxGrayFilter1.Median(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx())
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    'NstB^
    Private Sub btnSharp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSharp.Click

        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())
        AxFvxGrayFilter1.Sharp(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx())
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    '\[xtB^
    Private Sub btnSobel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSobel.Click

        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())
        AxFvxGrayFilter1.Sobel(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), FVXCOMGRAYFILTERLib.DIRECTION_TYPE.XY_DIRECTION)
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    'o[ctB^
    Private Sub btnRoberts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRoberts.Click

        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())
        AxFvxGrayFilter1.Roberts(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx())
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    '1
    Private Sub btnFdefferential_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFdefferential.Click

        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())
        AxFvxGrayFilter1.Fdefferential(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), FVXCOMGRAYFILTERLib.DIRECTION_TYPE.XY_DIRECTION)
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    '2tB^
    Private Sub btnSdefferential_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSdefferential.Click

        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())
        AxFvxGrayFilter1.Sdefferential(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx())
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    '[NXtB^
    Private Sub btnZeroCross_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZeroCross.Click

        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())
        AxFvxGrayFilter1.ZeroCross(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), 8, 255)
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    'CӈʒuNbVO
    Private Sub btnAnyCross_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAnyCross.Click

        AxFvxImage1.CopyTo(AxFvxImage2.GetOcx())
        AxFvxGrayFilter1.AnyCross(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), 8, 128, 255)
        AxFvxImage2.CopyTo(AxFvxImage1.GetOcx())

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub
End Class
